import { LRLanguage, LanguageSupport } from "@codemirror/language";
import { ViewPlugin, ViewUpdate, DecorationSet } from "@codemirror/view";
declare const NuformulaLanguage: LRLanguage;
declare function nuformula(): LanguageSupport;
type ItemOption = {
    label: string;
    [key: string]: any;
};
type Item = {
    sn: string;
    type: string;
    options: ItemOption;
    [key: string]: any;
};
/**
 * 輸出 表單元件 decoration 插件
 *
 * @param {object} formItems - 所有表單元件
 * @returns {ViewPlugin}
 */
declare function nuformulaItemWidget(formItems: {
    [key: string]: Item;
}): ViewPlugin<{
    decorations: DecorationSet;
    update(update: ViewUpdate): void;
}>;
// 輸出 linter
declare const nuformulaLinter: () => import("@codemirror/state").Extension;
// 語言標籤樣式
declare function nuformulaHighlightStyle(): import("@codemirror/state").Extension;
declare enum funcName {
    SUM = "SUM",
    AVERAGE = "AVERAGE",
    IF = "IF",
    CONCAT = "CONCAT"
}
/**
 * 輸出 自動選字 掛件
 *
 * @param {Object} options - 可選選項
 * @returns {Extension}
 */
declare function nuformulaAutocomplete(formItems: {
    [key: string]: Item;
}): import("@codemirror/state").Extension;
export { NuformulaLanguage, nuformula, nuformulaItemWidget, nuformulaLinter, nuformulaHighlightStyle, funcName, nuformulaAutocomplete, Item };
